<template>
  <div style="width:100%;">
    <template v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden'">
      <div ref="qrcode" class="qrcode" v-if="field.mobile">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        {{field.hiddenValue}}
      </div>
		</template>
		<template v-else-if="field.textType == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
			<template v-if="field.readOnlyShowValOnly">
      <!-- 只读（文本模式） -->
        <div ref="qrcode" class="qrcode" v-if="field.mobile">
          <div class="titleName">
            {{field.discript?field.discript:field.name}}
          </div>
          <div :id="id"  class="qrcode-wrap">
          </div>
        </div>
			</template>

			<template v-else>
				<div ref="qrcode" class="qrcode" v-if="field.mobile">
          <div class="titleName">
            {{field.discript?field.discript:field.name}}
          </div>
          <div :id="id"  class="qrcode-wrap">
          </div>
        </div>
			</template>
		</template>

		<template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
			<!--可编辑-->
      <div ref="qrcode" class="qrcode" v-if="field.mobile">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        <div :id="id"  class="qrcode-wrap">
        </div>
      </div>
		</template>
  </div>
</template>

<script>
import Constant from "@/Constant.js"
import QRCode from 'qrcodejs2'
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-qrcode",
  props: ["id"],
  computed: {
    field: function() {
      return this.$parent.findField(this.id);
    },
  },

  mounted(){
    let field = this.field;
    if(field.displayType != 3) {
      this.qrcode();
    }
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },

  data: function() {
    return {
      Constant,
    };
  },

  methods: {
    dianji(){
      let that = this
      let _native = top.nativeAPI ? top.nativeAPI : nativeAPI;
      _native.toQRScan({
        success: function (res) {
          that.resData = res;
        } 
      })
    },
    qrcode() {
      let text = '';
      let domainId = this.$store.state.domainId;
      let uuid = "";
      let len = 16;
      let chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
      let maxPos = chars.length;
      for (let i = 0; i < len; i++) {
        uuid += chars.charAt(Math.floor(Math.random() * maxPos));
      }
      let field = this.field;
      let randomCode = uuid;
      switch (field.handleType) {
        case "text": {//显示值
          text = this.field.value || ' '
          if(text.indexOf("?") > -1) {
            let v = text.split("?")
            text = v[0] + "?"+ v[1] //encodeURIComponent(v[1])
          }
          text = encodeURI(text)
          break;
        }
        case "link"://打开链接
        case "callback_event": {//执行扫码事件回调脚本
          let accessToken = Constant.accessToken;
          let formId = field.formId,
              docId = field.docId,
              fieldId = field.divId,
              applicationId = this.$root.appid;
          text = obpmConfig.obpmFilePath +"/portal/document/qrcodefield/ready?domainId=" + domainId + 
            "&formId=" + formId + 
            "&docId=" + docId + 
            "&fieldId=" + fieldId + 
            "&applicationId=" + applicationId + 
            "&_randomCode=" + randomCode + 
            "&accessToken=" + accessToken;
          text = encodeURI(text)
          break;
        }
        default:
          break;
      } 
      
      //text = host + "/obpm/portal/document/qrcodefield/ready?domainId=" + domainId + "&formId=" + formId + "&docId=" + docId + "&fieldId=" + fieldId + "&applicationId=" + applicationId + "&_randomCode=" + randomCode;
      let width ,
          height;
      if(this.field.displayType == 3){
        width = 0;
        height = 0;
      }else {
        width = this.field.size,
        height = this.field.size;
      }

      new QRCode(this.id, {
        width: width,  
        height: height,
        correctLevel: 3,
        text: text, // 二维码地址
      })
    },
  }
}
</script>
